﻿Option Explicit On
Option Strict On
Option Infer On




' ===============================================================
' Formulář s dírou - funkce API
' ===============================================================


Imports swf = System.Windows.Forms


Module mdBasDoura


' ----------------------------------------------------------------
' Deklarace funkcí a konstant Windows API:
' ----------------------------------------------------------------

   Public Const RGN_DIFF As Integer = 4

   Public Declare Function CreateRectRgn Lib "gdi32" _
      (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer

   Public Declare Function CreateEllipticRgn Lib "gdi32" _
      (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer

   Public Declare Function CombineRgn Lib "gdi32" _
      (ByVal hDestRgn As Integer, ByVal hSrcRgn1 As Integer, ByVal hSrcRgn2 As Integer, ByVal nCombineMode As Integer) As Integer

   Public Declare Function SetWindowRgn Lib "user32" _
      (ByVal hWnd As Integer, ByVal hRgn As Integer, ByVal bRedraw As Boolean) As Integer

   Public Declare Function DeleteObject Lib "gdi32" _
      (ByVal hObject As Integer) As Integer


' ----------------------------------------------------------------
' Hlavní program:
' ----------------------------------------------------------------

   Sub Main()

      ' Deklarace formuláře třídy frBASDOURA (má rozměry 500 x 400):
      Dim lFormular As New frDoura

      ' Vyříznutí elispy se středem [340, 270] a rozměrech 250 x 160:
      DerujFormular(lFormular, 340, 270, 250, 160)
      
      ' Zobrazení formuláře:
      lFormular.ShowDialog()

   End Sub


' ----------------------------------------------------------------
' Podprogram pro vyříznutí elipsy z formuláře:
' ----------------------------------------------------------------

   Public Sub DerujFormular(qF As swf.Form, qX As Integer, qY As Integer, qW As Integer, qH As Integer)

      ' Vytvoří ve formuláři qF průhledný eliptický region. Elipsa má střed [qX, qY]
      ' a šířku x výšku = qW x qH.

      Dim lIntPtr As IntPtr           ' Pointer na Handler
      Dim lHwnd As Integer            ' Handler formuláře

      Dim lRegionFormulare As Integer ' Region formuláře
      Dim lRegionElipsy As Integer    ' Region elipsy

      Dim lSirkaFormulare As Integer  ' Šířka formuláře
      Dim lVyskaFormulare As Integer  ' Výška formuláře

      Dim lStredFormulareX As Integer ' Souřadnice X středu formuláře
      Dim lStredFormulareY As Integer ' Souřadnice Y středu formuláře

      Dim lSirkaElipsy As Integer     ' Šířka elipsy
      Dim lVyskaElipsy As Integer     ' Výška elipsy

      Dim lStredElipsyX As Integer    ' Souřadnice X středu elipsy
      Dim lStredElipsyY As Integer    ' Souřadnice Y středu elipsy

      Dim lLHRelipsyX As Integer      ' Souřadnice X levého horního rohu elipsy
      Dim lLHRelipsyY As Integer      ' Souřadnice Y levého horního rohu elipsy

      Dim lPDRelipsyX As Integer      ' Souřadnice X pravého dolního rohu elipsy
      Dim lPDRelipsyY As Integer      ' Souřadnice Y pravého dolního rohu elipsy

      With qF

         ' Vnitřní rozměry formuláře:
         lSirkaFormulare = .Width
         lVyskaFormulare = .Height

         ' Střed formuláře
         lStredFormulareX = lSirkaFormulare \ 2
         lStredFormulareY = lVyskaFormulare \ 2

         ' Umístění elipsy :
         lStredElipsyX = qX
         lStredElipsyY = qY

         ' Rozměry elipsy:
         lSirkaElipsy = qW
         lVyskaElipsy = qH

         ' Levý horní roh elipsy:
         lLHRelipsyX = lStredElipsyX - lSirkaElipsy \ 2
         lLHRelipsyY = lStredElipsyY - lVyskaElipsy \ 2

         ' Pravý dolní roh elipsy:
         lPDRelipsyX = lStredElipsyX + lSirkaElipsy \ 2
         lPDRelipsyY = lStredElipsyY + lVyskaElipsy \ 2

         ' Regiony:
         lRegionFormulare = CreateRectRgn(0, 0, lSirkaFormulare, lVyskaFormulare)
         lRegionElipsy = CreateEllipticRgn(lLHRelipsyX, lLHRelipsyY, lPDRelipsyX, lPDRelipsyY)

         ' Logické operace s regiony:
         CombineRgn(lRegionFormulare, lRegionFormulare, lRegionElipsy, RGN_DIFF)

         ' Handler formuláře:
         lIntPtr = .Handle
         lHwnd = lIntPtr.ToInt32
         SetWindowRgn(lHwnd, lRegionFormulare, True)

         ' Odstranění zobrazování regionu elipsy:
         DeleteObject(lRegionElipsy)

      End With

   End Sub

End Module